
from yafs.selection import Selection
import networkx as nx
from yafs.topology import Topology
import json




class MinimunPath(Selection):

    def get_path(self, sim, app_name, message, topology_src, alloc_DES, alloc_module, traffic):
        """
        Computes the minimun path among the source elemento of the topology and the localizations of the module

        Return the path and the identifier of the module deployed in the last element of that path
        """
      
        
        z = nx.get_edge_attributes(sim.topology.G, 'BW')
        
        node_src1 = topology_src
        DES_dst = alloc_module[app_name][message.dst]
        w= list(nx.dfs_postorder_nodes(sim.topology.G, source=2, depth_limit=2))
        cost = [16, 36, 10, 37, 9, 5, 15, 5, 6, 60, 5, 18, 10, 6, 24, 12]
        n = int(topology_src)

        print (cost[n])
        print ("\tNode _ src (id_topology): %i" %node_src1)
        print ("\tRequest service: %s " %message.dst)
        print ("\tProcess serving that service: %s " %DES_dst)
       

        bestPath = []
        bestDES = []

        for des in DES_dst: ## In this case, there are only one deployment


            dst_node = alloc_DES[des]
            print ("\t\t Looking the path to id_node: %i" %dst_node)
            my_function()
            if message.name == "M.A":
               print ("***************************************************************************************************************************************************************************************************************************************************************************")
               print (message.name)
               node_src = topology_src
               i = 0
               a = 0
               while a < 50:
                 #a=cost[] 
                 i += 1
                 print(node_src)
                 w= list(nx.dfs_postorder_nodes(sim.topology.G, source=int(node_src1), depth_limit=i))
                 #a +=cost[node_src]
                 node_src=w[0]
                 print(w)
                 n = int(node_src)
                 a +=cost[n]
                 
               print(a)

               path = list(nx.shortest_path(sim.topology.G, source=node_src, target=dst_node, weight='WEIGHT', method='dijkstra'))
            
               bestPath = [path]
               bestDES = [des]
               break
            else: #message.name == "M.B"
                 path = list(nx.shortest_path(sim.topology.G, source=node_src, target=dst_node, weight='WEIGHT', method='dijkstra'))
            
                 bestPath = [path]
                 bestDES = [des]
                    


        return bestPath, bestDES

def my_function():
  print("Hello from a function")



class MinPath_RoundRobin(Selection):

    def __init__(self):
        self.rr = {} #for a each type of service, we have a mod-counter

    def get_path(self, sim, app_name, message, topology_src, alloc_DES, alloc_module, traffic):
        """
        Computes the minimun path among the source elemento of the topology and the localizations of the module

        Return the path and the identifier of the module deployed in the last element of that path
        """
        node_src = topology_src
        DES_dst = alloc_module[app_name][message.dst] #returns an array with all DES process serving


        if message.dst not in self.rr.keys():
            self.rr[message.dst] = 0


        print ("GET PATH")
        print ("\tNode _ src (id_topology): %i" %node_src)
        print ("\tRequest service: %s " %(message.dst))
        print ("\tProcess serving that service: %s (pos ID: %i)" %(DES_dst,self.rr[message.dst]))

        bestPath = []
        bestDES = []

        for ix,des in enumerate(DES_dst):
            if message.name == "M.A":
                if self.rr[message.dst]==ix:
                    dst_node = alloc_DES[des]

                    path = list(nx.shortest_path(sim.topology.G, source=node_src, target=dst_node))

                    bestPath = [path]
                    bestDES = [des]

                    self.rr[message.dst] = (self.rr[message.dst]+ 1) % len(DES_dst)
                    break
            else: #message.name == "M.B"

                dst_node = alloc_DES[des]

                path = list(nx.dijkstra_path(sim.topology.G, source=node_src, target=dst_node, weight='BW'))
                if message.broadcasting:
                    bestPath.append(path)
                    bestDES.append(des)
                else:
                    bestPath = [path]
                    bestDES = [des]

        return bestPath, bestDES

